/*
 * atl1reg.h
 * Macro definitions for Attansic L1 register definition
 * This file is public domain. Coded by Masa Murayama
 */

#pragma ident   "@(#)atl1reg.h	1.3 05/01/01"

#ifndef __ATL1REG_H__
#define	__ATL1REG_H__

/*
 * Register offset
 */
#define	PM_CTRLSTAT	0x0044	/* L1 L2 */
#define	PCIE_CAP_LIST	0x0058	/* L1 L2 */
#define	PCIE_DEVCTRL	0x0060	/* L1 */
#define	VPDCAP		0x006c	/* L1 L2 */
#define	VPDDATA		0x0070	/* L1 L2 */

#define	FLASHCTL	0x0200
#define	PCIE_DLLTXCTRL1	0x1104	/* L2 */
#define	LTSSM_TEST_MODE	0x12fc	/* L1 L2 */

#define	MSTC		0x1400	/* D: master control register L1 L2 */
#define	SOFTTIMER_INIT	0x1404	/* L1 L2 */
#define	INTRDELAY_INIT	0x1408	/* W: interrupt delay timer L1 L2 */
#define	INTRDELAY2_INIT	0x140a	/* W: L1E */
#define	GPHYC		0x140c	/* W: GPHY control register L1 L2 LE */
#define	INTRCLR_TIMER	0x140e	/* W: L1 L1E */
#define	IDLE		0x1410	/* D: idle status L1 L2 LE */
#define	MIIC		0x1414	/* D: mdio control L1 L2 */
#define	PHYSTAT		0x1418	/* L1E */
#define	SERDES_LOCK	0x1424	/* L2 */
#define	MACCTL		0x1480	/* D: mac control L1 L2 Le */
#define	GAPC		0x1484	/* D: L1 L2 Le */
#define	MACADDR		0x1488	/* D: L1 LE L2 */
#define	MHASH		0x1490	/* D: L1 LE L2 */
#define	HDCTL		0x1498	/* D: L1 L2 LE */
#define	MTU		0x149c	/* D: L1 L2 LE */
#define	WOLCTL		0x14a0	/* D: L1 L2 LE */
#define	WOLPAT		0x14a4	/* D*2: */

/*
 * chip family depend section
 */
/* L1 */
#define	RAM_RBD_BASE_1	0x1500
#define	RAM_RBD_SIZE_1	0x1504
#define	RAM_RSD_BASE_1	0x1508
#define	RAM_RSD_SIZE_1	0x150c
#define	RAM_TBD_BASE_1	0x1510
#define	RAM_TBD_SIZE_1	0x1514
#define	RAM_TRD_BASE_1	0x1518
#define	RAM_TRD_SIZE_1	0x151c
#define	RAM_RXF_BASE_1	0x1520
#define	RAM_RXF_SIZE_1	0x1524
#define	RAM_TXF_BASE_1	0x1528
#define	RAM_TXF_SIZE_1	0x152c
#define	RAM_TCPH_PATH_1	0x1530
#define	DESCEN_1	0x1534
#define	DESCBASE_1	0x1540	/* D: */
#define	RBDADDR_1	0x1544	/* D: */
#define	RSDADDR_1	0x1548	/* D: */
#define	TBDADDR_1	0x154c	/* D: */
#define	ISMADDR_1	0x1550
#define	SMADDR_1	0x1554
#define	RBD_RSD_CNT_1	0x1558
#define	TBD_CNT_1	0x155c
#define	TXQCTL_1		0x1580
#define	TXJCFG_1		0x1584
#define	RXQCTL_1		0x15a0
#define	RXJCFG_1		0x15a4
#define	RXFFC_1			0x15a8
#define	RSDFC_1			0x15ac
#define	DMAC_1			0x15c0
#define	ISMCTL_1		0x15d0	/* L1 */
#define	ISMTHRESH_1		0x15d4	/* L1 */
#define	ISMDELAY_1		0x15d8	/* L1 */
#define	ISM_RX_PKT_CNT_1	0x15dc	/* L1 */
#define	ISM_TX_PKT_CNT_1	0x15e0	/* L1 */
#define	SMDELAY_1		0x15e4	/* L1 */
#define	MBOX_1			0x15f0

/* L1E */
#define	IDT_TABLE4_1e		0x14e0
#define	IDT_TABLE5_1e		0x14e4
#define	IDT_TABLE6_1e		0x14e8
#define	IDT_TABLE7_1e		0x14ec
#define	RAM_TRD_BASE_1e		0x1518
#define	RAM_TRD_SIZE_1e		0x151c
#define	RAM_RXF_BASE_1e		0x1520
#define	RAM_RXF_SIZE_1e		0x1524
#define	RAM_TXF_BASE_1e		0x1528
#define	RAM_TXF_SIZE_1e		0x152c
#define	RAM_TCPH_PKTH_1e	0x1530
#define	DESCEN_1e		0x1534
#define	RXF3_RING_BASE_HI_1e	0x153c
#define	DESCBASE_1e		0x1540
#define	RXF0_RING_BASE_1e	0x1544	/* D*2: L1E */
#define	TBDADDR_1e		0x154c
#define	RXF1_RING_BASE_HI_1e	0x1550
#define	RXF2_RING_BASE_HI_1e	0x1554
#define	RXF_RING_HIWAT_1e	0x1558
#define	TBD_CNT_1e		0x155c
#define	IDT_TABLE0_1e		0x1560
#define	IDT_TABLE1_1e		0x1564
#define	IDT_TABLE2_1e		0x1568
#define	IDT_TABLE3_1e		0x156c
#define	RSS_HASH_VAL_1e		0x1570
#define	RSS_HASH_FLAG_1e	0x1574
#define	BASE_CPU_NUM_1e		0x157c
#define	TXQCTL_1e		0x1580
#define	TXJCFG_1e		0x1584
#define	RXQCTL_1e		0x15a0
#define	RXJCFG_1e		0x15a4
#define	RXFFC_1e		0x15a8
#define	RSDFC_1e		0x15ac
#define	DMAC_1e			0x15c0
#define	SM_TIMER_1e		0x15c4
#define	TX_COALSC_PKT_1e	0x15c8	/* W: L1E */
#define	RX_COALSC_PKT_1e	0x15ca	/* W: L1E */
#define	TX_COALSC_TO_1e		0x15cc	/* W: L1E */
#define	RX_COALSC_TO_1e		0x15ce	/* W: L1E */
#define	RXF1_RING_BASE_1e	0x15d0	/* D*2: L1E */
#define	RXF2_RING_BASE_1e	0x15d8	/* D*2: L1E */
#define	RXF3_RING_BASE_1e	0x15e0	/* D*2: L1E */
#define	MBOX_1e			0x15f0
#define	RXF_RING_VALID_1e	0x15f4	/* B*2*4: L1E */

/* L2 */
#define	RAMTXTAIL_2	0x1500	/* W: */
#define	RAMRXTAIL_2	0x1502	/* W: */
#define	DESCBASE_2	0x1540	/* D: */
#define	TBDADDR_2	0x1544	/* D: 4byte align */
#define	TBDLEN_2	0x1548	/* D: max 256KB */
#define	TSDADDR_2	0x154c	/* D: 4byte align */
#define	TSDCNT_2	0x1550	/* D: in 4 byte */
#define	RBDADDR_2	0x1554	/* D: 4byte align */
#define	RBDCNT_2	0x1558	/* D: in 1536 byte */
#define	DMAR_2		0x1580	/* W: */
#define	TXTHRESH_2	0x1590	/* D: in 2 byte */
#define	DMAW_2		0x15a0	/* W: */
#define	RXHIWAT_2	0x15a8	/* W: */
#define	RXLOWAT_2	0x15aa	/* W: */
#define	TBDTAIL_2	0x15f0	/* D: */
#define	RBDTAIL_2	0x15f4	/* D: */

/* common registers */
#define	ISR		0x1600	/* D: interrupt status */
#define	IMR		0x1604	/* D: interrupt mask */

/* L1 */
#define	CURR_RBD_RSD_1	0x1800
#define	CURR_TBD_1	0x1804

/* L1E */
#define	RXF0_BASE_1e	0x1800	/* L1E: not used */
#define	TBDHEAD_1e	0x1804	/* W: */
#define	RXF1_BASE_1e	0x1808	/* L1E: not used */
#define	RXF2_BASE_1e	0x180c	/* L1E: not used */
#define	RXF3_BASE_1e	0x1810	/* L1E: not used */
#define	RXF_RING_MB_1e	0x1820	/* D*2*4: dma address for rx head */
#define	TBD_TAIL_PTR_1e	0x1840
#define	SMB_ADDR_1e	0x1844


/*
 * Vendor specific MII PHY registers
 */
#define	MII_DBG_ADDR	0x1d
#define	MII_DBG_DATA	0x1e

/*
 * Register difinitions
 */
#define	VPDCAP_FLAG		0x80000000U
#define	VPDCAP_ADDR		0x7fff0000U
#define		VPDCAP_ADDR_SHIFT	16

/* flash control regster */
#define	FLASHCTL_WAIT_READY	0x10000000	/* X */
#define	FLASHCTL_EROM_PGSZ	0x0c000000	/* X */
#define		FLASHCTL_EROM_PGSZ_SHIFT	26	/* X */
#define	FLASHCTL_CS_SETUP	0x03000000	/* X */
#define		FLASHCTL_CS_SETUP_SHIFT	24	/* X */
#define	FLASHCTL_CLK_HI		0x00c00000	/* X */
#define		FLASHCTL_CLK_HI_SHIFT	22	/* X */
#define	FLASHCTL_CLK_LO		0x00300000	/* X */
#define		FLASHCTL_CLK_LO_SHIFT	20	/* X */
#define	FLASHCTL_CS_HOLD	0x000c0000	/* X */
#define		FLASHCTL_CS_HOLD_SHIFT	18	/* X */
#define	FLASHCTL_CS_HI		0x00030000	/* X */
#define		FLASHCTL_CS_HI_SHIFT	16	/* X */
#define	FLASHCTL_LDSTART	0x00008000	/* X */
#define	FLASHCTL_VPD_EN		0x00002000	/* X */
#define	FLASHCTL_START		0x00000800	/* X */
#define	FLASHCTL_INS		0x00000700	/* X */
#define		FLASHCTL_INS_SHIFT	8	/* X */
#define	FLASHCTL_STS_WPEN	0x00000080	/* X */
#define	FLASHCTL_STS		0x000000ff	/* X */
#define	FLASHCTL_STS_NON_RDY	0x00000001
#define	FLASHCTL_STS_WEN	0x00000002

/* MSTC: Master control register, offset 0x1400, L1/L2 */
#define	MSTC_DID		0xff000000U	/* device id */
#define		MSTC_DID_SHIFT	24U
#define		MSTC_DID_MASK	0xffU
#define	MSTC_REV		0x00ff0000U	/* chip revision */
#define		MSTC_REV_SHIFT	16U
#define		MSTCL_REV_MASK	0xffU
#define	MSTC_LEDMODE		0x00000200U	/* L1E */
#define	MSTC_INT_CLR		0x00000040U	/* L1E */
#define	MSTC_ITIMER2		0x00000020U	/* L1E */
#define	MSTC_SINT		0x00000008U	/* software interrupt */
#define	MSTC_ITIMER		0x00000004U	/* enable itimer */
#define	MSTC_MTIMER		0x00000002U	/* enable mtimer */
#define	MSTC_SRST		0x00000001U	/* software reset */

/* GPHYC: GPHY control register, offset 0x140c */
#define	GPHYC_PWDOWN_HW		0x4000	/* L1E */
#define	GPHYC_PHY_PLL_ON        0x2000	/* L1E */
#define	GPHYC_SEL_ANA_RST       0x1000	/* L1E */
#define	GPHYC_HIB_PULSE         0x0800	/* L1E */
#define	GPHYC_HIB_EN            0x0400	/* L1E */
#define	GPHYC_PCLK_SEL_DIS      0x0200	/* L1E */
#define	GPHYC_PHY_IDDQ_DIS      0x0100	/* L1E */
#define	GPHYC_PHY_IDDQ          0x0080	/* L1E */
#define	GPHYC_LPW_EXIT          0x0040	/* L1E */
#define	GPHYC_GATE_25M_EN       0x0020	/* L1E */
#define	GPHYC_BERT_START        0x0010	/* L1E */
#define	GPHYC_TESTMODE		0x000c	/* L1E */
#define		GPHYC_TESTMODE_SHIFT	2	/* L1E */
#define	GPHYC_PIPEMOD		0x0002	/* L1E */
#define	GPHYC_ENABLE		0x0001

#define	GPHYC_DEFAULT_1e	\
	(GPHYC_PHY_PLL_ON | GPHYC_SEL_ANA_RST | \
	GPHYC_HIB_PULSE | GPHYC_HIB_EN)


/* IDLE: idle status register */
#define	IDLE_ISM		0x00000080U	/* coaliscq */
#define	IDLE_SM			0x00000040U	/* statistics */
#define	IDLE_DMAW		0x00000020U	/* dma write */
#define	IDLE_DMAR		0x00000010U	/* dma read */
#define	IDLE_TXQ		0x00000008U	/* transmit queue */
#define	IDLE_RXQ		0x00000004U	/* recive queue */
#define	IDLE_TXMAC		0x00000002U	/* transmit side of mac */
#define	IDLE_RXMAC		0x00000001U	/* receive side of mac */

#define	IDLE_BITS	\
	"\020"	\
	"\010ISM"	\
	"\007SM"	\
	"\006DMAW"	\
	"\005DMAR"	\
	"\004TXQ"	\
	"\003RXQ"	\
	"\002TXMAC"

/* MII control Register */
#define	MIIC_BUSY		0x08000000U	/* MII opration in progress */
#define	MIIC_CLK		0x07000000U
#define		MIIC_CLK_SHIFT	24
#define		MIIC_CLK_4	(0U << MIIC_CLK_SHIFT)
#define		MIIC_CLK_6	(2U << MIIC_CLK_SHIFT)
#define		MIIC_CLK_8	(3U << MIIC_CLK_SHIFT)
#define		MIIC_CLK_10	(4U << MIIC_CLK_SHIFT)
#define		MIIC_CLK_14	(5U << MIIC_CLK_SHIFT)
#define		MIIC_CLK_20	(6U << MIIC_CLK_SHIFT)
#define		MIIC_CLK_28	(7U << MIIC_CLK_SHIFT)
#define	MIIC_GO			0x00800000U
#define	MIIC_SUPR		0x00400000U	/* supress preamble */
#define	MIIC_READ		0x00200000U
#define	MIIC_ADDR		0x001f0000U
#define		MIIC_ADDR_SHIFT	16
#define	MIIC_DATA		0x0000ffffU

/* PHY STATUS register, offset 0x1418 */
#define	PHYSTAT_100M	0x20000

/* MACCTL: MAC Control Register */
#define	MACCTL_HALFLEFTBUF	0xf0000000U
#define		MACCTL_HALFLEFTBUF_SHIFT	28
#define	MACCTL_DEBUG		0x08000000U
#define	MACCTL_AB		0x04000000U	/* accept broadcast */
#define	MACCTL_AAM		0x02000000U	/* accept all multicast */
#define	MACCTL_RCKSUM		0x01000000U	/* enable rx checksum */
#define	MACCTL_TXJUMBO		0x00800000U	/* enable tx jumbo packets */
#define	MACCTL_DBG_TX_BKPRESURE	0x00400000U	/* X */
#define	MACCTL_SPEED		0x00300000U	/* media speed */
#define		MACCTL_SPEED_SHIFT	20
#define		MACCTL_SPEED_1000	(2U << MACCTL_SPEED_SHIFT)
#define		MACCTL_SPEED_10_100	(1U << MACCTL_SPEED_SHIFT)
#define	MACCTL_TX_SIMURST	0x00080000U	/* X */
#define	MACCTL_SRST_TX		0x00040000U	/* X */
#define	MACCTL_SCNT		0x00020000U	/* X */
#define	MACCTL_TXPAUSE		0x00010000U	/* enable transmit pause */
#define	MACCTL_PROMISC		0x00008000U	/* promiscious mode */
#define	MACCTL_RXVTAG		0x00004000U	/* extract rx vtag */
#define	MACCTL_PRMLEN		0x00003c00U	/* preamble length */
#define		MACCTL_PRMLEN_SHIFT	10
#define	MACCTL_JUMBO		0x00000200U	/* allow jumbo packets */
#define	MACCTL_LENCHK		0x00000100U	/* X */
#define	MACCTL_AUTOPAD		0x00000080U	/* enable tx auto padding */
#define	MACCTL_CRCEN		0x00000040U	/* enable crc */
#define	MACCTL_FD		0x00000020U	/* full duplex */
#define	MACCTL_LBK		0x00000010U	/* loopback */
#define	MACCTL_RXFC		0x00000008U	/* enable rx flow control */
#define	MACCTL_TXFC		0x00000004U	/* enable tx flow control */
#define	MACCTL_RX		0x00000002U	/* enable rx */
#define	MACCTL_TX		0x00000001U	/* enable tx */

#define	MACCTL_BITS	\
	"\020"	\
	"\034DEBUG"	\
	"\033AB"	\
	"\032AAM"	\
	"\031RXCKSUM"	\
	"\030TX_JUMBO"	\
	"\027DBG_TX_BKPRESURE"	\
	"\024TX_SIMURST"	\
	"\023SRST_TX"	\
	"\022SCNT"	\
	"\021TXPAUSE"	\
	"\020PROMISC"	\
	"\017RXVTAG"	\
	"\012JUMBO"	\
	"\011LENCHK"	\
	"\010AUTOPAD"	\
	"\007CRCEN"	\
	"\006FD"	\
	"\005LBK"	\
	"\004RXFC"	\
	"\003TXFC"	\
	"\002RX"	\
	"\001TX"

/* GAP: inter-frame/inter-packet gap control register */
#define	GAPC_IPGR2		0x7f000000U
#define		GAPC_IPGR2_SHIFT	24
#define	GAPC_IPGR1		0x007f0000U
#define		GAPC_IPGR1_SHIFT	16
#define	GAPC_MIFG		0x0000ff00U
#define		GAPC_MIFG_SHIFT		8
#define	GAPC_IPGT		0x0000007fU
#define		GAPC_IPGT_SHIFT		0

#define	GAPC_STD		0x60405060U	/* standard configuration */

/* HDCTL: half duplex control register */
#define	HDCTRL_JAMIPG		0x0f000000U
#define		HDCTL_JAMIPG_SHIFT	24
#define	HDCTL_ABEBT		0x00f00000U
#define		HDCTL_ABEBT_SHIFT	20
#define	HDCTL_ABEBE		0x00080000U
#define	HDCTL_NO_BACK_P		0x00040000U
#define	HDCTL_NO_BACK_C		0x00020000U
#define	HDCTL_EXC_DEF		0x00010000U
#define	HDCTL_RETRY		0x0000f000U
#define		HDCTL_RETRY_SHIFT	12
#define	HDCTL_LCOL		0x000003ffU
#define		HDCTL_LCOL_SHIFT	0

#define	HDCTL_STD		0x07a1f037U	/* standard configuration */

/* WOL control */
#define	WOLCTL_PAT_EN		0x00000001	/* L1 L2 */
#define	WOLCTL_PAT_PME_EN	0x00000002	/* L1 L2 */
#define	WOLCTL_MGC_EN		0x00000004	/* L1 L2 */
#define	WOLCTL_MGC_PME_EN	0x00000008	/* L1 L2 */
#define	WOLCTL_LCHG_EN		0x00000010	/* L1 L2 */
#define	WOLCTL_LCHG_PME_EN	0x00000020	/* L1 L2 */
#define	WOLCTL_PAT_ST		0x00000100	/* L1 L2 */
#define	WOLCTL_MGC_ST		0x00000200	/* L1 L2 */
#define	WOLCTL_LCHN_ST		0x00000400	/* L1 L2 */
#define	WOLCTL_CLK_EN		0x00008000	/* L1 L2 */
#define	WOLCTL_PAT0_EN		0x00010000	/* L1 L2 */
#define	WOLCTL_PAT1_EN		0x00020000	/* L1 L2 */
#define	WOLCTL_PAT2_EN		0x00040000	/* L1 L2 */
#define	WOLCTL_PAT3_EN		0x00080000	/* L1 L2 */
#define	WOLCTL_PAT4_EN		0x00100000	/* L1 L2 */
#define	WOLCTL_PAT5_EN		0x00200000	/* L1 */
#define	WOLCTL_PAT6_EN		0x00400000	/* L1 */

#define	WOLCTL_PAT0_MATCH	0x01000000	/* L2 */
#define	WOLCTL_PAT1_MATCH	0x02000000	/* L2 */
#define	WOLCTL_PAT2_MATCH	0x04000000	/* L2 */
#define	WOLCTL_PAT3_MATCH	0x08000000	/* L2 */
#define	WOLCTL_PAT4_MATCH	0x10000000	/* L2 */

/* WOL pattern */
#define	WOLPAT0_PAT3		0x7f000000
#define		WOLPAT0_PAT3_SHIFT	24
#define	WOLPAT0_PAT2		0x007f0000
#define		WOLPAT0_PAT2_SHIFT	16
#define	WOLPAT0_PAT1		0x00007f00
#define		WOLPAT0_PAT1_SHIFT	8
#define	WOLPAT0_PAT0		0x0000007f
#define		WOLPAT0_PAT0_SHIFT	0

#define	WOLPAT1_PAT6		0x007f0000
#define		WOLPAT1_PAT6_SHIFT	16
#define	WOLPAT1_PAT5		0x00007f00
#define		WOLPAT1_PAT5_SHIFT	8
#define	WOLPAT1_PAT4		0x0000007f
#define		WOLPAT1_PAT4_SHIFT	0

/* Internal SRAM Partition Register */
#define	SRAM_PATH_ADDR		0x0fff0000U	/* X */
#define		SRAM_PATH_ADDR_SHIFT	16	/* X */
#define	SRAM_TCPH_ADDR		0x00000fffU	/* X */
#define		SRAM_TCPH_ADDR_SHIFT	0	/* X */

/* TXQCTL: TxQ control register */
#define	TXQCTL_TXF_BURST_NUM	0xffff0000U
#define		TXQCTL_TXF_BURST_NUM_SHIFT	16
#define	TXQCTL_TBD_FETCH_TH	0x00003f00U
#define		TXQCTL_TBD_FETCH_TH_SHIFT	8
#define	TXQCTL_ENH_MODE		0x00000040U
#define	TXQCTL_EN		0x00000020U
#define	TXQCTL_TBD_BURST_NUM	0x0000001fU
#define		TXQCTL_TBD_BURST_NUM_SHIFT	0

/* TX jumbo packet configuration */
#define	TXJCFG_TBDIPG		0x001f0000U
#define		TXJCFG_TBDIPG_SHIFT	16
#define	TXJCFG_THRESH	0x000007ffU
#define		TXJCFG_THRESH_SHIFT	0

/* RXQCTL: RxQ control register */
#define	RXQCTL_EN		0x80000000U
#define	RXQCTL_CUT_THRU_EN	0x40000000U
#define	RXQCTL_RBD_PREF_MIN_IPG	0x001f0000U
#define		RXQCTL_RBD_PREF_MIN_IPG_SHIFT	16
#define	RXQCTL_RSD_BURST_THRESH	0x0000ff00U
#define		RXQCTL_RSD_BURST_THRESH_SHIFT	8
#define	RXQCTL_RBD_BURST_NUM	0x000000ffU
#define		RXQCTL_RBD_BURST_NUM_SHIFT	0

/* for L1E */
#define	RXQCTL_HASH_EN		0x20000000U
#define	RXQCTL_NIP_QUEUE_SEL_TBL 0x10000000U
#define	RXQCTL_RSSMODE		0x0c000000U
#define		RXQCTL_RSSMODE_SHIFT	26U
#define		RXQCTL_RSSMODE_NONE	(0U << RXQCTL_RSS_MODE_SHIFT)
#define		RXQCTL_RSSMODE_SQSINT	(1U << RXQCTL_RSS_MODE_SHIFT)
#define		RXQCTL_RSSMODE_MQUESINT	(2U << RXQCTL_RSS_MODE_SHIFT)
#define		RXQCTL_RSSMODE_MQUEMINT	(3U << RXQCTL_RSS_MODE_SHIFT)
#define	RXQCTL_HTYPE_IPV6_TCP	0x00080000
#define	RXQCTL_HTYPE_IPV6	0x00040000
#define	RXQCTL_HTYPE_IPV4_TCP	0x00020000
#define	RXQCTL_HTYPE_IPV4	0x00010000 
#define	RXQCTL_HASH_TLEN	0x0000ff00
#define		RXQCTL_HASH_TLEN_SHIFT	8U
#define	RXQCTL_IPV6_CKSUM_EN	0x00000080
#define	RXQCTL_Q3_EN		0x00000040
#define	RXQCTL_Q2_EN		0x00000020
#define	RXQCTL_Q1_EN		0x00000010
#define	RXQCTL_PBA_ALIGN	0x00000003
#define		RXQCTL_PBA_ALIGN_32		0
#define		RXQCTL_PBA_ALIGN_64		1
#define		RXQCTL_PBA_ALIGN_128		2
#define		RXQCTL_PBA_ALIGN_256		3

/* RX jumbo packet configuration */
#define	RXJCFG_RSDTIMER		0xffff0000U	/* L1 */
#define		RXJCFG_RSDTIMER_SHIFT	16	/* L1 */
#define	RXJCFG_LKAH		0x00007800U
#define		RXJCFG_LKAH_SHIFT	11
#define	RXJCFG_THRESH		0x000007ffU
#define		RXJCFG_THRESH_SHIFT	0

/* RBD/RxFIFO flow control register */
#define	RXFFC_HIWAT		0x0fff0000U
#define		RXFFC_HIWAT_SHIFT	16
#define	RXFFC_LOWAT		0x00000fffU

/* RSD flow control register */
#define	RSDFC_LOWAT		0x0fff0000U
#define		RSDFC_LOWAT_SHIFT	16
#define	RSDFC_HIWAT		0x00000fffU

/* DMAC: dma control register */
#define	DMAC_RXCMB_1e		0x00200000U	/* L1E */
#define	DMAC_TXCMB_1e		0x00100000U	/* L1E */
#define	DMAC_DMAW_DLY_CNT_1e	0x000f0000U	/* L1E */
#define		DMAC_DMAW_DLY_CNT_SHIFT	16U	/* L1E */
#define	DMAC_DMAR_DLY_CNT_1e	0x0000f800U	/* L1E */
#define		DMAC_DMAR_DLY_CNT_SHIFT	11U	/* L1E */
#define	DMAC_DMAW_EN_1		0x00000800U	/* L1 */
#define	DMAC_DMAR_EN_1		0x00000400U	/* L1 */
#define	DMAC_DMAR_REQ_PRI_1e	0x00000400U	/* L1E */
#define	DMAC_DMAW_MAXDMA	0x00000380U
#define		MAXDMA_128	0U
#define		MAXDMA_256	1U
#define		MAXDMA_512	2U
#define		MAXDMA_1024	3U
#define		MAXDMA_2048	4U
#define		MAXDMA_4096	5U
#define		DMAC_DMAW_MAXDMA_SHIFT	7
#define		DMAC_DMAW_MAXDMA_128	(MAXDMA_128 << DMAC_DMAW_MAXDMA_SHIFT)
#define		DMAC_DMAW_MAXDMA_256	(MAXDMA_256 << DMAC_DMAW_MAXDMA_SHIFT)
#define		DMAC_DMAW_MAXDMA_512	(MAXDMA_512 << DMAC_DMAW_MAXDMA_SHIFT)
#define		DMAC_DMAW_MAXDMA_1024	(MAXDMA_1024 << DMAC_DMAW_MAXDMA_SHIFT)
#define		DMAC_DMAW_MAXDMA_2048	(MAXDMA_2048 << DMAC_DMAW_MAXDMA_SHIFT)
#define		DMAC_DMAW_MAXDMA_4096	(MAXDMA_4096 << DMAC_DMAW_MAXDMA_SHIFT)
#define	DMAC_DMAR_MAXDMA	0x00000070U
#define		DMAC_DMAR_MAXDMA_SHIFT	4
#define		DMAC_DMAR_MAXDMA_128	(MAXDMA_128 << DMAC_DMAR_MAXDMA_SHIFT)
#define		DMAC_DMAR_MAXDMA_256	(MAXDMA_256 << DMAC_DMAR_MAXDMA_SHIFT)
#define		DMAC_DMAR_MAXDMA_512	(MAXDMA_512 << DMAC_DMAR_MAXDMA_SHIFT)
#define		DMAC_DMAR_MAXDMA_1024	(MAXDMA_1924 << DMAC_DMAR_MAXDMA_SHIFT)
#define		DMAC_DMAR_MAXDMA_2048	(MAXDMA_2048 << DMAC_DMAR_MAXDMA_SHIFT)
#define		DMAC_DMAR_MAXDMA_4096	(MAXDMA_4096 << DMAC_DMAR_MAXDMA_SHIFT)
#define	DMAC_RCB_128		0x00000008U	/* 0:64, 1:128 */
#define	DMAC_DMAR_OUT_ORDER	0x00000004U
#define	DMAC_DMAR_ENH_ORDER	0x00000002U
#define	DMAC_DMAR_IN_ORDER	0x00000001U

/* ISMCTL: interrupt status message and statistics message */
#define	ISMCTL_SM_EN		0x00000008U
#define	ISMCTL_ISM_EN		0x00000004U
#define	ISMCTL_UPDATE_SM	0x00000002U
#define	ISMCTL_UPDATE_ISM	0x00000001U

/* ISMTHRESH: ISM DMA Write Threshold Register */
#define	ISMTHRESH_TBD		0x07ff0000U
#define		ISMTHRESH_TBD_SHIFT	16
#define	ISMTHRESH_RSD		0x000007ffU

/* ISMDELAY */
#define	ISMDELAY_TBD		0xffff0000U	/* in 2uS */
#define		ISMDELAY_TBD_SHIFT		16
#define	ISMDELAY_RSD		0x0000ffffU	/* in 2uS */

/* MBOX: mailbox register */
#define	MBOX_TBD_TAIL		0xffc00000U
#define		MBOX_TBD_TAIL_SHIFT	22
#define	MBOX_RSD_HEAD		0x003ff800U
#define		MBOX_RSD_HEAD_SHIFT	11
#define	MBOX_RBD_TAIL		0x000007ffU
#define		MBOX_RBD_TAIL_SHIFT	0

/* ISR: Interrupt Status Register, offset 0x1600 */
/* ISR bits for L1 chipset */
#define	ISR_DIS_INT_1		0x80000000U	/* X */
#define	ISR_DIS_DMA_1		0x40000000U	/* X */
#define	ISR_DIS_SM_1		0x20000000U	/* X */
#define	ISR_PCIE_ERR_1		0x10000000U
#define	ISR_CERR_1		0x08000000U
#define	ISR_NFER_1		0x04000000U
#define	ISR_FER_1			0x02000000U
#define	ISR_UR_1			0x01000000U
#define	ISR_MAC_TX_1		0x00800000U	/* X */
#define	ISR_MAC_RX_1		0x00400000U	/* X */
#define	ISR_ISM_TX_1		0x00200000U
#define	ISR_ISM_RX_1		0x00100000U
#define	ISR_RX_DMA_1		0x00080000U	/* X */
#define	ISR_TX_DMA_1		0x00040000U	/* X */
#define	ISR_TX_PKT_1		0x00020000U	/* X */
#define	ISR_RX_PKT_1		0x00010000U	/* X */
#define	ISR_GPHY_LOWPWR_1		0x00004000U	/* X */
#define	ISR_TX_CREGIT_1		0x00002000U	/* X */
#define	ISR_GPHY_1		0x00001000U	/* X */
#define	ISR_DMAW_TO_RST_1		0x00000800U	/* X */
#define	ISR_DMAR_TO_RST_1		0x00000400U	/* X */
#define	ISR_HOST_RSD_OVF_1	0x00000200U	/* X */
#define	ISR_HOST_RBD_UNRUN_1	0x00000100U	/* X */
#define	ISR_LINK_1		0x00000080U	/* X */
#define	ISR_TXF_UNRUN_1		0x00000040U	/* X */
#define	ISR_RSD_OVF_1		0x00000020U	/* X */
#define	ISR_RBD_UNRUN_1		0x00000010U	/* X */
#define	ISR_RXF_OVF_1		0x00000008U	/* X */
#define	ISR_MANUAL_1		0x00000004U	/* X */
#define	ISR_TIMER_1		0x00000002U	/* X */
#define	ISR_SM_1			0x00000001U

#define	ISR_BITS_1	\
	"\020"	\
	"\040DIS_INT"	\
	"\037DIS_DMA"	\
	"\036DIS_SM"	\
	"\035PCIE_ERR"	\
	"\034CERR"	\
	"\033NFERR"	\
	"\032FERR"	\
	"\031UR"	\
	"\030MAC_TX"	\
	"\027MAC_RX"	\
	"\026ISM_TX"	\
	"\025ISM_RX"	\
	"\024RX_DMA"	\
	"\023TX_DMA"	\
	"\022TX_PKT"	\
	"\021RX_PKT"	\
	"\015GPHY"	\
	"\014DMAW_TO_RST"	\
	"\013DMAR_TO_RST"	\
	"\012HOST_RSD_OV"	\
	"\011HOST_RBD_UNRUN"	\
	"\010LINK"	\
	"\007TXF_UNRUN"	\
	"\006RSD_OV"	\
	"\005RBD_UNRUN"	\
	"\004RXF_OV"	\
	"\003MANUAL"	\
	"\002TIMER"	\
	"\001SM"

/* ISR bits in L1E chipset */
#define	ISR_DIS_INT_1e		0x80000000U
#define	ISR_PCIE_ERR_1e		0x10000000U
#define	ISR_CERR_1e		0x08000000U
#define	ISR_NFER_1e		0x04000000U
#define	ISR_FER_1e		0x02000000U
#define	ISR_UR_1e		0x01000000U
#define	ISR_MAC_TX_1e		0x00800000U
#define	ISR_MAC_RX_1e		0x00400000U
#define	ISR_RX_PKT3_1e		0x00200000U
#define	ISR_RX_PKT2_1e		0x00100000U
#define	ISR_RX_PKT1_1e		0x00080000U
#define	ISR_TX_DMA_1e		0x00040000U
#define	ISR_TX_PKT_1e		0x00020000U
#define	ISR_RX_PKT_1e		0x00010000U
#define	ISR_GPHY_LOWPWR_1e	0x00004000U
#define	ISR_TX_CREGIT_1e	0x00002000U
#define	ISR_GPHY_1e		0x00001000U
#define	ISR_DMAW_TO_RST_1e	0x00000800U
#define	ISR_DMAR_TO_RST_1e	0x00000400U
#define	ISR_RX0_PAGE_FULL_1e	0x00000200U
#define	ISR_TXF_UNRUN_1e	0x00000100U
#define	ISR_RXF3_OV_1e		0x00000080U
#define	ISR_RXF2_OV_1e		0x00000040U
#define	ISR_RXF1_OV_1e		0x00000020U
#define	ISR_RXF0_OV_1e		0x00000010U
#define	ISR_RXF_OVF_1e		0x00000008U
#define	ISR_MANUAL_1e		0x00000004U
#define	ISR_TIMER_1e		0x00000002U
#define	ISR_SM_1e		0x00000001U

#define	ISR_BITS_1e	\
	"\020"	\
	"\040DIS_INT"	\
	"\035PCIE_ERR"	\
	"\034CERR"	\
	"\033NFERR"	\
	"\032FERR"	\
	"\031UR"	\
	"\030MAC_TX"	\
	"\027MAC_RX"	\
	"\026RX_PKT3"	\
	"\025RX_PKT2"	\
	"\024RX_PKT1"	\
	"\023TX_DMA"	\
	"\022TX_PKT"	\
	"\021RX_PKT"	\
	"\015GPHY"	\
	"\014DMAW_TO_RST"	\
	"\013DMAR_TO_RST"	\
	"\012RX0_PAGE_FULL"	\
	"\011TXF_UNRUN"	\
	"\010RX3_OV"	\
	"\007RX2_OV"	\
	"\006RX1_OV"	\
	"\005RX0_OV"	\
	"\004RXF_OVF"	\
	"\003MANUAL"	\
	"\002TIMER"	\
	"\001SM"

/* ISR bits for L2 chipset */
#define	ISR_DIS_INT_2		0x80000000U
#define	ISR_PCIE_ERR_2		0x10000000U
#define	ISR_CERR_2		0x08000000U
#define	ISR_NFER_2		0x04000000U
#define	ISR_FER_2		0x02000000U
#define	ISR_UR_2		0x01000000U
#define	ISR_TX_EARLY_2		0x00040000U
#define	ISR_RX_UPDATE_2		0x00020000U
#define	ISR_TX_UPDATE_2		0x00010000U
#define	ISR_GPHY_2		0x00000800U
#define	ISR_DMAW_TO_RST_2	0x00000400U
#define	ISR_DMAR_TO_RST_2	0x00000200U
#define	ISR_RXD_OV_2		0x00000100U
#define	ISR_TXD_UR_2		0x00000080U
#define	ISR_LINKCHG_2		0x00000040U
#define	ISR_RXS_OV_2		0x00000020U
#define	ISR_TXS_OV_2		0x00000010U
#define	ISR_TXF_UR_2		0x00000008U
#define	ISR_RXF_OVF_2		0x00000004U
#define	ISR_MANUAL_2		0x00000002U
#define	ISR_TIMER_2		0x00000001U

#define	ISR_BITS_2	\
	"\020"	\
	"\040DIS_INT"	\
	"\034PCIE_ERR"	\
	"\033CERR"	\
	"\032NFER"	\
	"\032FER"	\
	"\031UR"	\
	"\023TX_EARLY"	\
	"\022RX_UPDATE"	\
	"\021TX_UPDATE"	\
	"\014GPHY"	\
	"\013DMAW_TO_RST"	\
	"\012DMAR_TO_RST"	\
	"\011RXD_OV"	\
	"\010TXD_UR"	\
	"\007LINKCHG"	\
	"\006RXS_OV"	\
	"\005TXS_OV"	\
	"\004TXF_UR"	\
	"\003RXF_OVF"	\
	"\002MANUAL"	\
	"\001TIMER"


/* statistics information */
#define	STAT_RxOK		0
#define	STAT_RxBCAST		1
#define	STAT_RxMCAST		2
#define	STAT_RxPAUSE		3
#define	STAT_RxCTRL		4
#define	STAT_RxCRC		5
#define	STAT_RxLEN		6
#define	STAT_RxBYTE		7
#define	STAT_RxRUNT		8
#define	STAT_RxFRAG		9
#define	STAT_Rx64		10
#define	STAT_Rx65_127		11
#define	STAT_RX128_255		12
#define	STAT_Rx256_511		13
#define	STAT_Rx512_1023		14
#define	STAT_Rx1024_1518	15
#define	STAT_Rx1519_MAX		16
#define	STAT_RxLONG		17
#define	STAT_RxFIFO		18
#define	STAT_RxNORRD		19
#define	STAT_RxALIGN		20
#define	STAT_RxBCAST_BYTE	21
#define	STAT_RxMCAST_BYTE	22
#define	STAT_RxADDR		23
#define	STAT_TxOK		24
#define	STAT_TxBCAST		25
#define	STAT_TxMCAST		26
#define	STAT_TxPAUSE		27
#define	STAT_TxEXCDEFER		28
#define	STAT_TxCTRL		29
#define	STAT_TxDEFER		30
#define	STAT_TxBYTE		31
#define	STAT_Tx64		32
#define	STAT_Tx65_127		33
#define	STAT_Tx128_255		34
#define	STAT_Tx256_511		35
#define	STAT_Tx512_1023		36
#define	STAT_Tx1024_1518	37
#define	STAT_Tx1519_MAX		38
#define	STAT_Tx1COL		39
#define	STAT_TxMCOL		40
#define	STAT_TxLATE_COL		41
#define	STAT_TxABORT		42
#define	STAT_TxUNDERRUN		43
#define	STAT_TxRD_EOP		44
#define	STAT_TxLEN		45
#define	STAT_TxTRUNC		46
#define	STAT_TxBCAST_BYTE	47
#define	STAT_TxMCAST_BYTE	48
#define	STAT_SM_VALID		49
#define	STAT_MAX		50

/* Interrupt Status Message */
struct intr_status_msg {
	volatile uint32_t	ism_isr;	/* copy of ISR */
	volatile uint16_t	ism_rsd;	/* current rx status desc */
	volatile uint16_t	ism_rbd;	/* current rx buffer desc */
	volatile uint16_t	ism_unused;
	volatile uint16_t	ism_tbd;	/* current tx buffer desc */
};

/* rx status descriptor */
struct rx_status_desc {
	volatile uint64_t	rsd0;
	volatile uint64_t	rsd1;
};

#define	RSD0_CPU_1e	0xc000000000000000ULL
#define		RSD0_CPU_SHIFT_1e	62
#define	RSD0_LEN	0xffff000000000000ULL
#define	RSD0_LEN_1e	0x3fff000000000000ULL
#define		RSD0_LEN_SHIFT		48
#define	RSD0_CKSUM	0x0000ffff00000000ULL
#define		RSD0_CKSUM_SHIFT	32
#define	RSD0_INDEX	0x00000000ffff0000ULL
#define		RSD0_INDEX_SHIFT	16
#define	RSD0_NUM	0x00000000000000ffULL
#define	RSD0_SEQNUM	0x000000000000ffffULL

#define	RSD0_OWN	(RSD0_LEN | RSD0_CKSUM)

#define	RSD1_VTAG	0xffff000000000000ULL
#define		RSD0_VTAG_SHIFT		48
#define	RSD1_FLAGS	0x00000000ffffffffULL
#define		RSD1_E_DES_ADDR	0x02000000U	/*  */
#define		RSD1_E_LEN	0x01000000U	/* length error */
#define		RSD1_E_L4CHKSUM	0x00800000U	/* TCP/UDP cksum error */
#define		RSD1_E_IPCHKSUM	0x00400000U	/* IP cksum error */
#define		RSD1_E_TRUNC	0x00200000U	/* trancated */
#define		RSD1_E_OVF	0x00100000U	/* overflow */
#define		RSD1_E_RUNT	0x00080000U	/* too short */
#define		RSD1_E_DRIBBLE	0x00040000U	/* dribble error */
#define		RSD1_E_CODE	0x00020000U	/*  */
#define		RSD1_E_CRC	0x00010000U	/* crc error */
#define		RSD1_PAUSE	0x00008000U	/* pause packet */
#define		RSD1_MCAST	0x00004000U	/* multicast */
#define		RSD1_BCAST	0x00002000U	/* broadcast */
#define		RSD1_TCP	0x00001000U	/* tcp */
#define		RSD1_UDP	0x00000800U	/* udp */
#define		RSD1_IPv4	0x00000400U	/* ipv4 */
#define		RSD1_ERR	0x00000200U	/* error */
#define		RSD1_VLAN_INS	0x00000100U	/* vlan tag is inserted */
#define		RSD1_ETH_TYPE	0x00000080U	/* snap  */
#define		RSD1_IPv4_DF	0x00000040U	/* ipv4 */
#define		RSD1_IPv4_MF	0x00000020U	/* ipv4 */
#define		RSD1_IPv6_MF	0x00000010U	/* ipv6 */
#define		RSD1_RSS_IP6TCP	0x00000008U	/* ipv6 TCP */
#define		RSD1_RSS_IP6	0x00000004U	/* ipv6 */
#define		RSD1_RSS_IP4TCP	0x00000002U	/* ipv4 TCP */
#define		RSD1_RSS_IP4	0x00000001U	/* ipv4 */

#define	RSD1_BITS	\
	"\020"	\
	"\032E_DES_ADDR"	\
	"\031E_LEN"	\
	"\030E_L4_CHKSUM"	\
	"\027E_IP_CHKSUM"	\
	"\026E_TRUNC"	\
	"\025E_OV"	\
	"\024E_RUNT"	\
	"\023E_DRIBBLE"	\
	"\022E_CODE"	\
	"\021E_CRC"	\
	"\020PAUSE"	\
	"\017MCAST"	\
	"\016BCAST"	\
	"\015TCP"	\
	"\014UDP"	\
	"\013IPv4"	\
	"\012ERR"	\
	"\011VLAN_INS"	\
	"\010ETH_TYPE"

struct rx_buffer_desc {
	volatile uint32_t	rb_addr;
	volatile uint32_t	rb_haddr;
	volatile uint32_t	rb_flags;
};

struct tx_buffer_desc {
	volatile uint64_t	tb_addr;
	volatile uint64_t	tb_flags;
};

#define	TBF_CKSUMOFF	0xff00000000000000ULL	/* cksum */
#define		TBF_CKSUMOFF_SHIFT	56
#define	TBF_PAYLDOFF	0x00ff000000000000ULL	/* cksum */
#define		TBF_PAYLDOFF_SHIFT	48
#define	TBF_MSS		0xfff8000000000000ULL	/* tso */
#define		TBF_MSS_SHIFT	51
#define	TBF_HDRFLG	0x0004000000000000ULL	/* tso */
#define	TBF_TCPHL	0x0003c00000000000ULL	/* tso */
#define		TBF_TCPHL_SHIFT	46
#define	TBF_IPHL	0x00003c0000000000ULL	/* tso */
#define		TBF_IPHL_SHIFT	42
#define	TBF_ETHTYPE	0x0000020000000000ULL	/* soft vlan tagged */
#define	TBF_VTAGGED	0x0000010000000000ULL
#define	TBF_UDPC	0x0000008000000000ULL
#define	TBF_TCPC	0x0000004000000000ULL
#define	TBF_IPC		0x0000002000000000ULL
#define	TBF_SEGMENT	0x0000001000000000ULL
#define	TBF_CKSUM	0x0000000800000000ULL
#define	TBF_INSVTAG	0x0000000400000000ULL
#define	TBF_COALESE	0x0000000200000000ULL
#define	TBF_EOP		0x0000000100000000ULL
#define	TBF_VTAG	0x00000000ffff0000ULL
#define		TBF_VTAG_SHIFT	16
#define	TBF_PKTINT	0x0000000000008000ULL
#define	TBF_DMAINT	0x0000000000004000ULL
#define	TBF_BUFLEN	0x0000000000003fffULL	/* 14bit */

/* tx header for L2 */
#define	TH_PKTSIZE	0x000007ffU
#define	TH_INSVTAG	0x00008000U
#define	TH_VTAG		0xffff0000U
#define	TH_VTAG_SHIFT		16U

/* rx status for L2 */
#define	RS_UPDATE	0x80000000U
#define	RS_VLAN		0x08000000U
#define	RS_ALIGN	0x04000000U
#define	RS_TRUNC	0x02000000U
#define	RS_FRAG		0x01000000U
#define	RS_RUNT		0x00800000U
#define	RS_CODE		0x00400000U
#define	RS_CRC		0x00200000U
#define	RS_CTRL		0x00100000U
#define	RS_PAUSE	0x00080000U
#define	RS_MCAST	0x00040000U
#define	RS_BCAST	0x00020000U
#define	RS_OK		0x00010000U
#define	RS_PKTSIZE	0x000007ffU

#define	RS_BITS	\
	"\020"	\
	"\040UPDATE"	\
	"\034VLAN"	\
	"\033ALIGN"	\
	"\032TRUNC"	\
	"\031FRAG"	\
	"\030RUNT"	\
	"\027CODE"	\
	"\026CRC"	\
	"\025CTRL"	\
	"\024PAUSE"	\
	"\023MCAST"	\
	"\022BCAST"	\
	"\021OK"	

/* tx status for L2 */
#define	TS_UPDATE	0x80000000U
#define	TS_URUN		0x08000000U
#define	TS_ABORT	0x04000000U
#define	TS_LATE		0x02000000U
#define	TS_MCOL		0x01000000U
#define	TS_SCOL		0x00800000U
#define	TS_EXC		0x00400000U
#define	TS_DEFER	0x00200000U
#define	TS_CTRL		0x00100000U
#define	TS_PAUSE	0x00080000U
#define	TS_MCAST	0x00040000U
#define	TS_BCAST	0x00020000U
#define	TS_OK		0x00010000U
#define	TS_PKTSIZE	0x000007ffU

#define	TS_BITS	\
	"\020"	\
	"\040UPDATE"	\
	"\034URUN"	\
	"\033ABORT"	\
	"\032LATE"	\
	"\031MCOL"	\
	"\030SCOL"	\
	"\027EXC"	\
	"\026DEFER"	\
	"\025CTRL"	\
	"\024PAUSE"	\
	"\023MCAST"	\
	"\022BCAST"	\
	"\021OK"

#endif /* __ATL1REG_H__ */
